'use strict'

const carga_builder = require('../../builder/carga-builder');
const {RetornoModel} = require('../../models/retorno-model');

exports.post = async (repository, validationContract, req, res) => {
    let _retorno = new RetornoModel(req.body.token_do_processo, null, null);

    try {
        let data = req.body
        if (!validationContract.isValid()) {
            _retorno.errores = validationContract.errors()

            res.status(422)
                .send(_retorno)
                .end()
            console.error('errorValidationContract', JSON.stringify(validationContract))
            return
        }

        let resultado = await repository.create(data, req.usuarioLogado)

        if (resultado.errores.find((r) => r.codigo === 500)) {
            res.status(500)
                .send(resultado)
                .end()
            return
        }

        res.status(201).send(resultado)
    } catch (err) {
        console.error(`Error en la importación:`, err)
        _retorno.errores = err

        res.status(500).send(_retorno)
    }
}

exports.getMetaDatos = (req, res) => {
    try {
        let resultado = carga_builder.CARGA_BINDING_IN_META
        res.status(200).send(resultado)
    } catch (err) {
        console.error(`getMetaDatos com erro, motivo:`, err)
        res.status(500).send({
            message: 'Erro no processamento',
            error: err
        })
    }
}

exports.getExamples = (req, res) => {
    try {
        const file = __dirname + '../../../resources/CARGA.API/testes/v1-importacao-trading-romaneo.xlsx';
        res.download(file);
    } catch (e) {
        console.error(`getDocs con error, motivo:`, e)
        res.status(500).send({
            message: 'Erro en el procesamiento',
            error: e
        })
    }
}

exports.getDocs = (req, res) => {
    try {
        const file = __dirname + '../../../resources/CARGA.API/doc/v1-importacao-documentacao.xlsx';
        res.download(file);
    } catch (e) {
        console.error(`getDocs con error, motivo:`, e)
        res.status(500).send({
            message: 'Erro en el procesamiento',
            error: e
        })
    }
}
