'user strict';

require(`object-mapper`);
const {CARGA_BINDING_IN_META, DESCONTO_BINDING_IN_META} = require(`../../../builder/carga-builder`)

function newObj(meta) {
    let newObjVar = {};

    Object.keys(meta).forEach(key => {
        if (meta[key].hasOwnProperty('default')) {
            newObjVar[key] = meta[key].default;
        } else {
            newObjVar[key] = null;
        }
    })

    return newObjVar;
}

function doCargaMap(source) {
    let descontos = [];
    let carga = new newObj(CARGA_BINDING_IN_META);

    if (Array.isArray(source.descontos) && source.descontos.length > 0) {
        source.descontos.forEach(d => descontos.push(Object.assign(new newObj(DESCONTO_BINDING_IN_META), d)))
    }

    Object.assign(carga, source);

    return {...carga, descontos: descontos}
}

module.exports = {doCargaMap};
