const oracledb = require('oracledb')

const CARGA_BINDING_IN_META = {
    uuid: {type: oracledb.STRING, typeIn: 'String', maxSize: 32, dir: oracledb.BIND_IN},
    cod_carga: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_plan_financ: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    cod_tp_carga: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    cod_departamento: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    cod_localidad: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    cod_analisis: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_sucursal: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    cod_mercaderia: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    cod_silo: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    tipo_negociacion: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN},
    situacion: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN, default: 'F'},
    cod_usuario: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    cod_variedad: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_doc_impreso: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_clasificacion: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_suc_translado: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_dep_translado: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_item_translado: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_tec_monsanto: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_regla_apro: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    num_viaje: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_usua_cerrado: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    doc_generado: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    fe_emision: {type: oracledb.STRING, typeIn: 'Date', required: true, maxSize: 19, isDate: true, dir: oracledb.BIND_IN},
    peso_negociado: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    peso_funda: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    peso_bruto: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    peso_tara: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    peso_neto: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    peso_descuento: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    peso_liquido: {type: oracledb.NUMBER, typeIn: 'Number', required: true, dir: oracledb.BIND_IN},
    peso_desc_embarque: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    fe_orides: {type: oracledb.STRING, typeIn: 'Date', maxSize: 19, isDate: true, dir: oracledb.BIND_IN},
    peso_neto_orides: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    peso_liquido_orides: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_remisaoe_orides: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_remisaoo_orides: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    otros_codigos: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    fe_descarga: {type: oracledb.STRING, typeIn: 'Date', maxSize: 19, isDate: true, dir: oracledb.BIND_IN},
    doc_orides: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN, required: true},
    cod_roman_temp_orides: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    doc_roman_tempo_orides: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_remis_temp_orides: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    doc_roman_tempe_orides: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_entidad: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_contrato: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_factura_exp: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_enti_entrega: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    ctr_costo: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    ctr_precio: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    apropriada: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN},
    cod_transportadora: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    nro_camion: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    nom_chofer: {type: oracledb.STRING, typeIn: 'String', maxSize: 100, dir: oracledb.BIND_IN},
    doc_chofer: {type: oracledb.STRING, typeIn: 'String', maxSize: 20, dir: oracledb.BIND_IN},
    chapa_camion: {type: oracledb.STRING, typeIn: 'String', maxSize: 10, dir: oracledb.BIND_IN},
    chapa_remolque: {type: oracledb.STRING, typeIn: 'String', maxSize: 10, dir: oracledb.BIND_IN},
    cod_moneda: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    vlr_flete_tons: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    vlr_flete_tot: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    vlr_flete_contabil: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    tipo_transporte: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN},
    modelo_tractor: {type: oracledb.STRING, typeIn: 'String', maxSize: 20, dir: oracledb.BIND_IN},
    direccion_chofer: {type: oracledb.STRING, typeIn: 'String', maxSize: 50, dir: oracledb.BIND_IN},
    cod_chofer: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_unid_veic_camion: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_unid_veic_remolque: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_orden_carga: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_resp_flete: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN, default: '0'},
    tp_neg_flete: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN},
    cod_cuenta_deb_flete: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_centro_costo_deb_flete: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    fe_venc_debito: {type: oracledb.STRING, typeIn: 'Date', maxSize: 19, isDate: true, dir: oracledb.BIND_IN},
    tasa_interes_deb_flete: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_cuenta_cred_flete: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_centro_costo_cred_flete: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    fe_venc_credito: {type: oracledb.STRING, typeIn: 'Date', maxSize: 19, isDate: true, dir: oracledb.BIND_IN},
    tasa_int_cred_flete: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    fe_analisis: {type: oracledb.STRING, typeIn: 'Date', maxSize: 19, isDate: true, dir: oracledb.BIND_IN},
    obs_analisis: {type: oracledb.STRING, typeIn: 'String', maxSize: 80, dir: oracledb.BIND_IN},
    situ_analisis: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN, default: 'F'},
    ent_sai_analisis: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN},
    cod_cor_analisis: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    vlr_renta_analisis: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    genera_devo_analisis: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_precio_arroz_analisis: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    vlr_arroz_analisis: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    analisis_electronica: {type: oracledb.STRING, typeIn: 'String', maxSize: 2000, dir: oracledb.BIND_IN},
    cod_usua_analisis: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    motivo_analisis_manual: {type: oracledb.STRING, typeIn: 'String', maxSize: 2000, dir: oracledb.BIND_IN},
    peso_bruto_por_balanza: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN},
    gen_flete: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN},
    clt_monsanto: {type: oracledb.STRING, typeIn: 'String', maxSize: 16, dir: oracledb.BIND_IN},
    fe_reg_peso_bruto: {type: oracledb.STRING, typeIn: 'Date', maxSize: 19, isDate: true, dir: oracledb.BIND_IN},
    fe_cierre_carga: {type: oracledb.STRING, typeIn: 'Date', maxSize: 19, isDate: true, required: true, dir: oracledb.BIND_IN},
    peso_tara_por_balanza: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN},
    nro_orden_flete: {type: oracledb.STRING, typeIn: 'String', maxSize: 13, dir: oracledb.BIND_IN},
    comp_translado: {type: oracledb.STRING, typeIn: 'String', maxSize: 13, dir: oracledb.BIND_IN},
    obs: {type: oracledb.STRING, typeIn: 'String', maxSize: 80, dir: oracledb.BIND_IN},
    cod_motivo: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    fe_registro: {type: oracledb.STRING, typeIn: 'Date', maxSize: 19, isDate: true, dir: oracledb.BIND_IN},
    fe_registro_tara: {type: oracledb.STRING, typeIn: 'Date', maxSize: 19, isDate: true, dir: oracledb.BIND_IN},
    nombre_tolva: {type: oracledb.STRING, typeIn: 'String', maxSize: 15, dir: oracledb.BIND_IN},
    cod_parcela_semilla: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_analista: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_orden_flete: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    orden_carga: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    valor_flete_devedor: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN}
}

const DESCONTO_BINDING_IN_META = {
    uuid: {type: oracledb.STRING, typeIn: 'String', maxSize: 32, dir: oracledb.BIND_IN},
    resultado_analise: {type: oracledb.STRING, typeIn: 'String', maxSize: 1, dir: oracledb.BIND_IN},
    cod_analisis: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    cod_desconto: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    peso_analisado: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    percentual_analise: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN},
    peso_descontado: {type: oracledb.NUMBER, typeIn: 'Number', dir: oracledb.BIND_IN}
}

const CARGA_BINDING_OUT = {
    RETORNO_CODE: {type: oracledb.NUMBER, dir: oracledb.BIND_OUT},
    RETORNO_MSG: {type: oracledb.STRING, dir: oracledb.BIND_OUT, SIZE: 32767}
}

const SQL_CARGA_INSERT =
    `insert into backup_tables.etl_carga
        (uuid,      ncodicarg, ncodiplfi, ncoditpca, ncodidepa, 
         ncodiloca, ncodianca, ncodifili, ncodimerc, ncodisilo, 
         ctpngcarg, csitucarg, ncodiusua, ncodivari, ncdficarg, 
         ncodicfca, ncdfimvts, ncddemvts, ncodimvts, ncoditcms, 
         ncodirese, ncodirevi, ncdufusua, ndogecarg, ddtemcarg, 
         npnegcarg, npfuncarg, npbrucarg, nptarcarg, npnetcarg, 
         ntdescarg, npliqcarg, npbrzcarg, ddataorde, npnetorde, 
         npliqorde, ncdreorde, ncdroorde, nocdcorde, ddtdeorde, 
         ndocuorde, nciroorde, ndiroorde, ncireorde, ndireorde, 
         ncodienti, ncodictcv, ncodifatu, nenetcaen, nnumefecu, 
         nnumefepr, capctcaen, ncdtrenti, nncamfret, cnomofret, 
         cdcmofret, cpcamfret, cprebfret, ncodimoed, nvlfrfret, 
         nvalofret, nvlcofret, ctptrfret, cmotrfret, cendemotr, 
         ncodimotr, ncodiuvca, ncodiuvre, ncodiorca, crefrfrin, 
         ctpngfrin, ncrdbcont, nccdbccus, dvedbfrin, ntxjdfrin, 
         ncrcrcont, ncccrccus, dvecrfrin, ntxjcfrin, ddataanca, 
         cobs_anca, csituanca, censaanca, ncodicore, nvlreanca, 
         cgdfuanca, ncodiptal, nvlaranca, canelanca, ncodiusua_anca, 
         cmotianca, cpbrccarg, csefrcarg, ccltmcarg, dhpbrcarg, 
         ddtficarg, cptaccarg, cnroordem, cccommvts, cobs_carg, 
         ncodimoti, ddtrgcarg, dhptacarg, cmoegcarg, ncodiparc, 
         ncodienti_anca,       ncodiorfr, norcafrex, nvlfdfrin)
    values
        (:uuid,      :cod_carga, :cod_plan_financ, :cod_tp_carga, :cod_departamento, 
         :cod_localidad, :cod_analisis, :cod_sucursal, :cod_mercaderia, :cod_silo, 
         :tipo_negociacion, :situacion, :cod_usuario, :cod_variedad, :cod_doc_impreso, 
         :cod_clasificacion, :cod_suc_translado, :cod_dep_translado, :cod_item_translado, :cod_tec_monsanto, 
         :cod_regla_apro, :num_viaje, :cod_usua_cerrado, :doc_generado, to_date(:fe_emision, 'DD/MM/YYYY HH24:MI:SS'), 
         :peso_negociado, :peso_funda, :peso_bruto, :peso_tara, :peso_neto, 
         :peso_descuento, :peso_liquido, :peso_desc_embarque, to_date(:fe_orides, 'DD/MM/YYYY HH24:MI:SS'), :peso_neto_orides, 
         :peso_liquido_orides, :cod_remisaoe_orides, :cod_remisaoo_orides, :otros_codigos, to_date(:fe_descarga, 'DD/MM/YYYY HH24:MI:SS'), 
         :doc_orides, :cod_roman_temp_orides, :doc_roman_tempo_orides, :cod_remis_temp_orides, :doc_roman_tempe_orides, 
         :cod_entidad, :cod_contrato, :cod_factura_exp, :cod_enti_entrega, :ctr_costo, 
         :ctr_precio, :apropriada, :cod_transportadora, :nro_camion, :nom_chofer, 
         :doc_chofer, :chapa_camion, :chapa_remolque, :cod_moneda, :vlr_flete_tons, 
         :vlr_flete_tot, :vlr_flete_contabil, :tipo_transporte, :modelo_tractor, :direccion_chofer, 
         :cod_chofer, :cod_unid_veic_camion, :cod_unid_veic_remolque, :cod_orden_carga, :cod_resp_flete, 
         :tp_neg_flete, :cod_cuenta_deb_flete, :cod_centro_costo_deb_flete, to_date(:fe_venc_debito, 'DD/MM/YYYY HH24:MI:SS'), :tasa_interes_deb_flete, 
         :cod_cuenta_cred_flete, :cod_centro_costo_cred_flete, to_date(:fe_venc_credito, 'DD/MM/YYYY HH24:MI:SS'), :tasa_int_cred_flete, to_date(:fe_analisis, 'DD/MM/YYYY HH24:MI:SS'), 
         :obs_analisis, :situ_analisis, :ent_sai_analisis, :cod_cor_analisis, :vlr_renta_analisis, 
         :genera_devo_analisis, :cod_precio_arroz_analisis, :vlr_arroz_analisis, :analisis_electronica, :cod_usua_analisis, 
         :motivo_analisis_manual, :peso_bruto_por_balanza, :gen_flete, :clt_monsanto, to_date(:fe_reg_peso_bruto, 'DD/MM/YYYY HH24:MI:SS'), 
         to_date(:fe_cierre_carga, 'DD/MM/YYYY HH24:MI:SS'), :peso_tara_por_balanza, :nro_orden_flete, :comp_translado, :obs, 
         :cod_motivo, :fe_registro, to_date(:fe_registro_tara, 'DD/MM/YYYY HH24:MI:SS'), :nombre_tolva, :cod_parcela_semilla, 
         :cod_analista, :cod_orden_flete, :orden_carga, :valor_flete_devedor)
    `

const SQL_DESCONTO_INSERT =
        `insert into backup_tables.etl_desconto_carga (uuid, ncodianca, ncodidepr, npeandeca, npededeca, npsdedeca, caneldeca)
         values (:uuid, :cod_analisis, :cod_desconto, :peso_analisado, :percentual_analise, :peso_descontado, :resultado_analise)`

const PLSQL_PROCESSA_CARGA =
    `declare
       result DOLPHIN_API_BAL.RETORNO_TYPE;                           
       RETORNO_CODE number;
       RETORNO_MSG VARCHAR2(32767);        
     begin     
       result := DOLPHIN_API_BAL.PROCESSA_CARGA(TOKEN_IN => :TOKEN_IN);
       :RETORNO_CODE := result.CODE;
       :RETORNO_MSG  := TRIM(result.MESSAGE);
     end;`

const PLSQL_GENERATE_NEW_ID_CARGA =
    `declare
       NEW_ID number;
     begin
       :NEW_ID := DOLPHIN_API_BAL.GENERATE_NEW_ID_CARGA(NCODIFILI => :cod_sucursal,
                                                         NCODIDEPA => :cod_departamento);
     end;`

const PLSQL_GENERATE_NEW_ID_ANALISE =
    `declare
       NEW_ID number;
     begin
       :NEW_ID := DOLPHIN_API_BAL.GENERATE_NEW_ID_ANALISE(NCODIFILI => :cod_sucursal,
                                                           NCODIDEPA => :cod_departamento);
     end;`

const SQL_GET_CARGAS_FINALIZADAS = `SELECT NCODICARG, UUID
                                    FROM BACKUP_TABLES.ETL_CARGA
                                    ORDER BY NCODICARG`

function convertType() {
    return Object.values(CARGA_BINDING_IN_META)
}

const START_PROCESS =
        `INSERT INTO BACKUP_TABLES.ETL_PROCESSO (TOKEN,
                                                 STATUS,
                                                 TOTAL,
                                                 PROCESSADO,
                                                 INICIADO,
                                                 MENSAGEM,
                                                 ISTRADE,
                                                 MODULO,
                                                 SEND_JSON)
         VALUES (:0, 'I', :1, 0, SYSDATE, 'Iniciado...', :2, 'CARGAS', :3)`

module.exports = {
    PLSQL_PROCESSA_CARGA, CARGA_BINDING_OUT, SQL_CARGA_INSERT, SQL_DESCONTO_INSERT,
    PLSQL_GENERATE_NEW_ID_CARGA, PLSQL_GENERATE_NEW_ID_ANALISE, SQL_GET_CARGAS_FINALIZADAS, convertType,
    START_PROCESS, DESCONTO_BINDING_IN_META, CARGA_BINDING_IN_META
}
