"use strict"

const validation = require('../bin/helpers/valida-carga')
const _ctrlBase = require('../bin/base/controller-base')
const _mapper = require(`../bin/helpers/map/carga-mapper`)
const CargaService = require(`../service/carga-service`)

class cargaController {

    constructor() {
    }

    async post(req, res) {
        let cargas = []

        if (Array.isArray(req.body.cargas)) {
            req.body.cargas
                .forEach(c => cargas.push(_mapper.doCargaMap(c)))
            req.body.cargas = cargas
        }

        let _validationContract = new validation(req)
        let _service = new CargaService({schema: req.usuarioLogado.schema})
        await _ctrlBase.post(_service, _validationContract, req, res)
    }

    metadatos(req, res) {
        _ctrlBase.getMetaDatos(req, res)
    }

    examples(req, res) {
        _ctrlBase.getExamples(req, res)
    }

    docs(req, res) {
        _ctrlBase.getDocs(req, res)
    }
}

module.exports = cargaController
