-- Create table
drop table BACKUP_TABLES.ETL_CARGA;

create global temporary table BACKUP_TABLES.ETL_CARGA
(
    token          VARCHAR2(32),
    uuid           VARCHAR2(32),
    ncodicarg      NUMBER(8),
    ncodiplfi      NUMBER(3),
    ncoditpca      NUMBER(3),
    ncodidepa      NUMBER(2),
    ncodiloca      NUMBER(4),
    ncodianca      NUMBER(8),
    ncodifili      NUMBER(2),
    ncodimerc      NUMBER(6),
    ncodisilo      NUMBER(3),
    ctpngcarg      CHAR(1) default 'S',
    csitucarg      VARCHAR2(1) default 'A',
    ncodiusua      NUMBER(3) default 1,
    ncodivari      NUMBER(3),
    ncdficarg      NUMBER(13),
    ncodicfca      NUMBER(2),
    ncdfimvts      NUMBER,
    ncddemvts      NUMBER,
    ncodimvts      NUMBER,
    ncoditcms      NUMBER,
    ncodirese      NUMBER,
    ncodirevi      NUMBER(5),
    ncdufusua      NUMBER(3),
    ndogecarg      NUMBER(8),
    ddtemcarg      DATE,
    npnegcarg      NUMBER(10) default 0,
    npfuncarg      NUMBER(10) default 0,
    npbrucarg      NUMBER(10) default 0,
    nptarcarg      NUMBER(10) default 0,
    npnetcarg      NUMBER(10) default 0,
    ntdescarg      NUMBER(10) default 0,
    npliqcarg      NUMBER(10) default 0,
    npbrzcarg      NUMBER(1) default 0,
    ddataorde      DATE,
    npnetorde      NUMBER(10),
    npliqorde      NUMBER(10),
    ncdreorde      NUMBER(6),
    ncdroorde      NUMBER(13),
    nocdcorde      NUMBER(6),
    ddtdeorde      DATE,
    ndocuorde      NUMBER(8),
    nciroorde      NUMBER(6),
    ndiroorde      NUMBER(6),
    ncireorde      NUMBER(6),
    ndireorde      NUMBER(6),
    ncodienti      NUMBER(6),
    ncodictcv      NUMBER,
    ncodifatu      NUMBER(8),
    nenetcaen      NUMBER(6),
    nnumefecu      NUMBER,
    nnumefepr      NUMBER,
    capctcaen      VARCHAR2(1) default 'A',
    ncdtrenti      NUMBER(6),
    nncamfret      NUMBER(5),
    cnomofret      VARCHAR2(100),
    cdcmofret      VARCHAR2(20),
    cpcamfret      VARCHAR2(10),
    cprebfret      VARCHAR2(10),
    ncodimoed      NUMBER(2),
    nvlfrfret      NUMBER(15,2),
    nvalofret      NUMBER(15,2) default 0,
    nvlcofret      NUMBER(15,2) default 0,
    ctptrfret      CHAR(1) default 'C',
    cmotrfret      VARCHAR2(20),
    cendemotr      VARCHAR2(50),
    ncodimotr      NUMBER(6),
    ncodiuvca      NUMBER(6),
    ncodiuvre      NUMBER(6),
    ncodiorca      NUMBER,
    crefrfrin      CHAR(1) default '0',
    ctpngfrin      CHAR(1) default 'S',
    ncrdbcont      NUMBER(5),
    nccdbccus      NUMBER(3),
    dvedbfrin      DATE,
    ntxjdfrin      NUMBER(5,2) default 0,
    ncrcrcont      NUMBER(5),
    ncccrccus      NUMBER(3),
    dvecrfrin      DATE,
    ntxjcfrin      NUMBER(5,2) default 0,
    ddataanca      DATE,
    cobs_anca      VARCHAR2(80),
    csituanca      VARCHAR2(1) default 'A',
    censaanca      CHAR(1),
    ncodicore      NUMBER(8),
    nvlreanca      NUMBER(15,2),
    cgdfuanca      VARCHAR2(1) default 'S',
    ncodiptal      NUMBER(6),
    nvlaranca      NUMBER(19,8),
    canelanca      NVARCHAR2(2000),
    ncodiusua_anca NUMBER(3),
    cmotianca      VARCHAR2(100),
    cpbrccarg VARCHAR2(1) default 'N',
    csefrcarg VARCHAR2(1) default 'N',
    ccltmcarg VARCHAR2(16),
    dhpbrcarg DATE default SYSDATE,
    ddtficarg DATE,
    cptaccarg VARCHAR2(1) default 'N',
    cnroordem VARCHAR2(13),
    cccommvts VARCHAR2(15),
    cobs_carg VARCHAR2(80),
    ncodimoti NUMBER(3),
    ddtrgcarg DATE default SYSDATE,
    dhptacarg DATE,
    cmoegcarg VARCHAR2(15),
    ncodiparc NUMBER(6),
    ncodienti_anca number(6)	
)
    on commit delete rows;
-- Add comments to the columns
comment on column BACKUP_TABLES.ETL_CARGA.ncodienti_anca 
    is 'cod_analista';
comment on column BACKUP_TABLES.ETL_CARGA.cpbrccarg
    is 'peso_bruto_por_balanca';
comment on column BACKUP_TABLES.ETL_CARGA.csefrcarg
    is 'gera_frete';
comment on column BACKUP_TABLES.ETL_CARGA.ccltmcarg
    is 'clt_monsanto';
comment on column BACKUP_TABLES.ETL_CARGA.dhpbrcarg
    is 'hora_peso_bruto';
comment on column BACKUP_TABLES.ETL_CARGA.ddtficarg
    is 'data_fechamento_carga';
comment on column BACKUP_TABLES.ETL_CARGA.cptaccarg
    is 'peso_tara_por_balanca';
comment on column BACKUP_TABLES.ETL_CARGA.cnroordem
    is 'nro_ordem_frete';
comment on column BACKUP_TABLES.ETL_CARGA.cccommvts
    is 'comp_translado';
comment on column BACKUP_TABLES.ETL_CARGA.cobs_carg
    is 'obs';
comment on column BACKUP_TABLES.ETL_CARGA.ncodimoti
    is 'cod_motivo';
comment on column BACKUP_TABLES.ETL_CARGA.ddtrgcarg
    is 'data_registro';
comment on column BACKUP_TABLES.ETL_CARGA.dhptacarg
    is 'data_registro_tara';
comment on column BACKUP_TABLES.ETL_CARGA.cmoegcarg
    is 'nome_tolva';
comment on column BACKUP_TABLES.ETL_CARGA.ncodiparc
    is 'cod_parcela_semente';
comment on column BACKUP_TABLES.ETL_CARGA.ncodicarg
    is 'cod_carga';
comment on column BACKUP_TABLES.ETL_CARGA.ncodiplfi
    is 'cod_plan_financ';
comment on column BACKUP_TABLES.ETL_CARGA.ncoditpca
    is 'cod_tp_carga';
comment on column BACKUP_TABLES.ETL_CARGA.ncodidepa
    is 'cod_departamento';
comment on column BACKUP_TABLES.ETL_CARGA.ncodiloca
    is 'cod_localidade';
comment on column BACKUP_TABLES.ETL_CARGA.ncodianca
    is 'cod_analise';
comment on column BACKUP_TABLES.ETL_CARGA.ncodifili
    is 'cod_filial';
comment on column BACKUP_TABLES.ETL_CARGA.ncodimerc
    is 'cod_mercadoria';
comment on column BACKUP_TABLES.ETL_CARGA.ncodisilo
    is 'cod_silo';
comment on column BACKUP_TABLES.ETL_CARGA.ctpngcarg
    is 'tipo_negociacao';
comment on column BACKUP_TABLES.ETL_CARGA.csitucarg
    is 'situacao';
comment on column BACKUP_TABLES.ETL_CARGA.ncodiusua
    is 'cod_usuario';
comment on column BACKUP_TABLES.ETL_CARGA.ncodivari
    is 'cod_variedade';
comment on column BACKUP_TABLES.ETL_CARGA.ncdficarg
    is 'cod_doc_impresso';
comment on column BACKUP_TABLES.ETL_CARGA.ncodicfca
    is 'cod_classificacao';
comment on column BACKUP_TABLES.ETL_CARGA.ncdfimvts
    is 'cod_suc_translado';
comment on column BACKUP_TABLES.ETL_CARGA.ncddemvts
    is 'cod_dep_translado';
comment on column BACKUP_TABLES.ETL_CARGA.ncodimvts
    is 'cod_item_translado';
comment on column BACKUP_TABLES.ETL_CARGA.ncoditcms
    is 'cod_tec_monsanto';
comment on column BACKUP_TABLES.ETL_CARGA.ncodirese
    is 'cod_regra_apro';
comment on column BACKUP_TABLES.ETL_CARGA.ncodirevi
    is 'num_viagem';
comment on column BACKUP_TABLES.ETL_CARGA.ncdufusua
    is 'cod_usua_fechou';
comment on column BACKUP_TABLES.ETL_CARGA.ndogecarg
    is 'doc_gerado';
comment on column BACKUP_TABLES.ETL_CARGA.ddtemcarg
    is 'data_emissao';
comment on column BACKUP_TABLES.ETL_CARGA.npnegcarg
    is 'peso_negociado';
comment on column BACKUP_TABLES.ETL_CARGA.npfuncarg
    is 'peso_funda';
comment on column BACKUP_TABLES.ETL_CARGA.npbrucarg
    is 'peso_bruto';
comment on column BACKUP_TABLES.ETL_CARGA.nptarcarg
    is 'peso_tara';
comment on column BACKUP_TABLES.ETL_CARGA.npnetcarg
    is 'peso_neto';
comment on column BACKUP_TABLES.ETL_CARGA.ntdescarg
    is 'peso_desconto';
comment on column BACKUP_TABLES.ETL_CARGA.npliqcarg
    is 'peso_liquido';
comment on column BACKUP_TABLES.ETL_CARGA.npbrzcarg
    is 'peso_desc_embarque';
comment on column BACKUP_TABLES.ETL_CARGA.ddataorde
    is 'data_orides';
comment on column BACKUP_TABLES.ETL_CARGA.npnetorde
    is 'peso_neto_orides';
comment on column BACKUP_TABLES.ETL_CARGA.npliqorde
    is 'peso_liquido_orides';
comment on column BACKUP_TABLES.ETL_CARGA.ncdreorde
    is 'cod_remisao_orides';
comment on column BACKUP_TABLES.ETL_CARGA.ncdroorde
    is 'cod_remisao_orides';
comment on column BACKUP_TABLES.ETL_CARGA.nocdcorde
    is 'outros_codigos';
comment on column BACKUP_TABLES.ETL_CARGA.ddtdeorde
    is 'data_descarga';
comment on column BACKUP_TABLES.ETL_CARGA.ndocuorde
    is 'doc_orides';
comment on column BACKUP_TABLES.ETL_CARGA.nciroorde
    is 'cod_roman_temp_orides';
comment on column BACKUP_TABLES.ETL_CARGA.ndiroorde
    is 'doc_roman_temp_orides';
comment on column BACKUP_TABLES.ETL_CARGA.ncireorde
    is 'cod_remis_temp_orides';
comment on column BACKUP_TABLES.ETL_CARGA.ndireorde
    is 'doc_roman_temp_orides';
comment on column BACKUP_TABLES.ETL_CARGA.ncodienti
    is 'cod_entidade';
comment on column BACKUP_TABLES.ETL_CARGA.ncodictcv
    is 'cod_contrato';
comment on column BACKUP_TABLES.ETL_CARGA.ncodifatu
    is 'cod_factura_exp';
comment on column BACKUP_TABLES.ETL_CARGA.nenetcaen
    is 'cod_enti_entrega';
comment on column BACKUP_TABLES.ETL_CARGA.nnumefecu
    is 'ctr_custo';
comment on column BACKUP_TABLES.ETL_CARGA.nnumefepr
    is 'ctr-preco';
comment on column BACKUP_TABLES.ETL_CARGA.capctcaen
    is 'apropriada';
comment on column BACKUP_TABLES.ETL_CARGA.ncdtrenti
    is 'cod_transportadora';
comment on column BACKUP_TABLES.ETL_CARGA.nncamfret
    is 'nro_caminhao';
comment on column BACKUP_TABLES.ETL_CARGA.cnomofret
    is 'nom_motorista';
comment on column BACKUP_TABLES.ETL_CARGA.cdcmofret
    is 'doc_motorista';
comment on column BACKUP_TABLES.ETL_CARGA.cpcamfret
    is 'placa_caminhao';
comment on column BACKUP_TABLES.ETL_CARGA.cprebfret
    is 'placa_reboque';
comment on column BACKUP_TABLES.ETL_CARGA.ncodimoed
    is 'cod_moeda';
comment on column BACKUP_TABLES.ETL_CARGA.nvlfrfret
    is 'vrl_frete_tons';
comment on column BACKUP_TABLES.ETL_CARGA.nvalofret
    is 'valor_frete_tot';
comment on column BACKUP_TABLES.ETL_CARGA.nvlcofret
    is 'valor_frete_contabil';
comment on column BACKUP_TABLES.ETL_CARGA.ctptrfret
    is 'tipo_transporte';
comment on column BACKUP_TABLES.ETL_CARGA.cmotrfret
    is 'modelo_trator';
comment on column BACKUP_TABLES.ETL_CARGA.cendemotr
    is 'endereco_motorista';
comment on column BACKUP_TABLES.ETL_CARGA.ncodimotr
    is 'cod_motorista';
comment on column BACKUP_TABLES.ETL_CARGA.ncodiuvca
    is 'cod_unid_veic_caminhao';
comment on column BACKUP_TABLES.ETL_CARGA.ncodiuvre
    is 'cod_unid_veic_reboque';
comment on column BACKUP_TABLES.ETL_CARGA.ncodiorca
    is 'cod_ordem_carga';
comment on column BACKUP_TABLES.ETL_CARGA.crefrfrin
    is 'cod_resp_frete';
comment on column BACKUP_TABLES.ETL_CARGA.ctpngfrin
    is 'tipo_negociacao_frete';
comment on column BACKUP_TABLES.ETL_CARGA.ncrdbcont
    is 'cod_conta_debito_frete';
comment on column BACKUP_TABLES.ETL_CARGA.nccdbccus
    is 'cod_centro_custo_debito_frete';
comment on column BACKUP_TABLES.ETL_CARGA.dvedbfrin
    is 'data_vencimento_debito';
comment on column BACKUP_TABLES.ETL_CARGA.ntxjdfrin
    is 'taxa_juros_debito_frete';
comment on column BACKUP_TABLES.ETL_CARGA.ncrcrcont
    is 'cod_conta_credito_frete';
comment on column BACKUP_TABLES.ETL_CARGA.ncccrccus
    is 'cod_centro_custo_credito_frete';
comment on column BACKUP_TABLES.ETL_CARGA.dvecrfrin
    is 'data_vencimento_credito';
comment on column BACKUP_TABLES.ETL_CARGA.ntxjcfrin
    is 'taxa_juros_credito_frete';
comment on column BACKUP_TABLES.ETL_CARGA.ddataanca
    is 'data_analise';
comment on column BACKUP_TABLES.ETL_CARGA.cobs_anca
    is 'obs_analise';
comment on column BACKUP_TABLES.ETL_CARGA.csituanca
    is 'situ_analise';
comment on column BACKUP_TABLES.ETL_CARGA.censaanca
    is 'entrada_saida_analise';
comment on column BACKUP_TABLES.ETL_CARGA.ncodicore
    is 'cod_cor_analise';
comment on column BACKUP_TABLES.ETL_CARGA.nvlreanca
    is 'vlr_renda_analise';
comment on column BACKUP_TABLES.ETL_CARGA.cgdfuanca
    is 'gera_devolucao_analise';
comment on column BACKUP_TABLES.ETL_CARGA.ncodiptal
    is 'cod_preco_arroz_analise';
comment on column BACKUP_TABLES.ETL_CARGA.nvlaranca
    is 'vlr_arroz_analise';
comment on column BACKUP_TABLES.ETL_CARGA.canelanca
    is 'analise_eletronica';
comment on column BACKUP_TABLES.ETL_CARGA.ncodiusua_anca
    is 'cod_usua_analise';
comment on column BACKUP_TABLES.ETL_CARGA.cmotianca
    is 'motivo_analise_manual';
comment on column BACKUP_TABLES.ETL_CARGA.token
    is 'token_do_processo';

drop table BACKUP_TABLES.ETL_DESCONTO_CARGA;

-- Create table
create global temporary table BACKUP_TABLES.ETL_DESCONTO_CARGA
(
    uuid      VARCHAR2(32),
    ncodianca NUMBER(8),
    ncodidepr NUMBER(3),
    npeandeca NUMBER(5,2),
    npededeca NUMBER(5,2),
    npsdedeca NUMBER(10),
    caneldeca VARCHAR2(1) default 'N', --analise_eletronica,
    token     VARCHAR2(32)
)
    on commit delete rows;
-- Add comments to the columns
comment on column BACKUP_TABLES.ETL_DESCONTO_CARGA.ncodianca
    is 'cod_analise';
comment on column BACKUP_TABLES.ETL_DESCONTO_CARGA.ncodidepr
    is 'cod_desconto';
comment on column BACKUP_TABLES.ETL_DESCONTO_CARGA.npeandeca
    is 'percentual_analisado';
comment on column BACKUP_TABLES.ETL_DESCONTO_CARGA.npededeca
    is 'percentual_descontado';
comment on column BACKUP_TABLES.ETL_DESCONTO_CARGA.npsdedeca
    is 'peso_descontado';
comment on column BACKUP_TABLES.ETL_DESCONTO_CARGA.caneldeca
    is 'analise_eletronica';
comment on column BACKUP_TABLES.ETL_DESCONTO_CARGA.token
    is 'token_do_processo';

drop table BACKUP_TABLES.ETL_PROCESSO;

-- Create table
create table BACKUP_TABLES.ETL_PROCESSO
(
    token      VARCHAR2(32),
    status     CHAR(1),
    total      INTEGER,
    processado INTEGER,
    iniciado   DATE default SYSDATE,
    finalizado DATE,
    modulo     VARCHAR2(50),
    mensagem   VARCHAR2(1000),
    log	       clob
);
-- Add comments to the columns
comment on column BACKUP_TABLES.ETL_PROCESSO.modulo
    is 'modulo do processo';
comment on column BACKUP_TABLES.ETL_PROCESSO.token
    is 'token do processo';
comment on column BACKUP_TABLES.ETL_PROCESSO.status
    is 'status do processo';
comment on column BACKUP_TABLES.ETL_PROCESSO.total
    is 'total a processar';
comment on column BACKUP_TABLES.ETL_PROCESSO.processado
    is 'total processado';
comment on column BACKUP_TABLES.ETL_PROCESSO.iniciado
    is 'data e hora que iniciou o processo';
comment on column BACKUP_TABLES.ETL_PROCESSO.finalizado
    is 'data e hora que finalizou o processo';
comment on column BACKUP_TABLES.ETL_PROCESSO.mensagem
    is 'mensagem do processamento';
comment on column BACKUP_TABLES.ETL_PROCESSO.log
    is 'log de execucao';

-- Add/modify columns
alter table BACKUP_TABLES.ETL_PROCESSO add ISTRADE varchar2(1) default 'N';
-- Add comments to the columns
comment on column BACKUP_TABLES.ETL_PROCESSO.ISTRADE
  is 'Operación de trade?';

-- Add/modify columns
alter table BACKUP_TABLES.ETL_CARGA add ncodiorfr number(10);
alter table BACKUP_TABLES.ETL_CARGA add norcafrex number(10);
-- Add comments to the columns
comment on column BACKUP_TABLES.ETL_CARGA.ncodiorfr
  is 'cod_orden_flete';
comment on column BACKUP_TABLES.ETL_CARGA.norcafrex
  is 'orden_carga';

-- Add/modify columns
alter table BACKUP_TABLES.ETL_PROCESSO add log_error clob;
-- Add comments to the columns
comment on column BACKUP_TABLES.ETL_PROCESSO.log_error
  is 'Log de errores';

-- Add/modify columns
alter table BACKUP_TABLES.ETL_CARGA add nvlfdfrin number(15,2);
-- Add comments to the columns
comment on column BACKUP_TABLES.ETL_CARGA.nvlfdfrin
  is 'valor_frete_devedor';

-- Add/modify columns
alter table BACKUP_TABLES.ETL_PROCESSO add SEND_JSON clob;
-- Add comments to the columns
comment on column BACKUP_TABLES.ETL_PROCESSO.SEND_JSON
  is 'JSON object was send';

drop table BACKUP_TABLES.ETL_PROCESSO_CARGA;

  -- Create table
create table BACKUP_TABLES.ETL_PROCESSO_CARGA
(
  token     VARCHAR2(32) not null,
  ncodicarg NUMBER(8) not null
)
;
-- Add comments to the table
comment on table BACKUP_TABLES.ETL_PROCESSO_CARGA
  is 'Vinculo del proceso con las cargas generadas';
-- Add comments to the columns
comment on column BACKUP_TABLES.ETL_PROCESSO_CARGA.token
  is 'token do processo';
comment on column BACKUP_TABLES.ETL_PROCESSO_CARGA.ncodicarg
  is 'cod_carga';

-- Add comments to the columns
comment on column BACKUP_TABLES.ETL_PROCESSO.status
  is 'status do processo > (I)niciado
(P)rocessando
(F)inalizado';


grant select, insert, update, delete, references, alter, index, debug on BACKUP_TABLES.ETL_PROCESSO to public;
grant select, insert, update, delete, references, alter, index, debug on BACKUP_TABLES.ETL_CARGA to public;
grant select, insert, update, delete, references, alter, index, debug on BACKUP_TABLES.ETL_DESCONTO_CARGA to public;
grant select, insert, update, delete, references, alter, index, debug on BACKUP_TABLES.ETL_PROCESSO_CARGA to public;
